<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en">
<head>
	<title>CarbonPHP Documentation</title>
	<style type="text/css">
		* {
			margin: 0;
			padding: 0;
		}

		html {
			font-family: "Lucida Sans Unicode", "Lucida Grande";
			font-size: 14px;
		}

		body {
			background: #fff;
			color: #666;
		}

		h1 {
			font-size: 15px;
			font-weight: bold;
			margin: 0 0 5px 0;
		}

		h2 {
			font-size: 13px;
			font-weight: bold;
			margin: 5px 0 5px 0;
		}

		ol, ul {
			margin: 10px 0 10px 0;
			list-style-position: inside;
		}

		p {
			margin: 5px 0 5px 0;
		}

		.content {
			border: 1px dotted #444;
			margin: 10px;
			padding: 10px;
			text-align: justify;
			width: 700px;
		}

		.example {
			border: 1px solid #ccc;
			background: #eee;
			margin: 10px;
			padding: 10px;
			text-align: left;
		}
	</style>
</head>

<body>
	<div class="content">
		<h1>Connecting to a Database</h1>

		<p>There are two methods of connecting to a database.</p>
	</div>

	<div class="content">
		<h1>Connecting Automatically</h1>

		<p>The automatically connecting feature will loads and initialise the database class with every page load. To
		enable this, add the <b>database</b> library to the autoload array in the
		<b>application/config/autoload.php</b> file.</p>
	</div>

	<div class="content">
		<h1>Connecting Manually</h1>

		<p>If you only need to connect to your database for some pages you can manually load the database class.  To
		load the database class you add the following method to any method or function where you need to use a
		database.</p>

		<div class="example">
			$this->load->database();
		</div>

		<p>If the method does not contain any parameters it will connect using the group specified in the database
		configuration file <b>application/config/database.php</b>, this is the method most people will use.</p>

		<p>The first parameter of the method can optionally be used to specify database connection settings.</p>

		<p>You can pass a specific group name to the method to load a specific set of database connection settings.</p>

		<div class="example">
			$this->load->database('<b>group_name</b>');
		</div>

		<p>You can also manually pass an array of connection settings to the method.</p>

		<div class="example">
			$config['hostname'] = 'localhost';<br />
			$config['username'] = 'myusername';<br />
			$config['password'] = 'mypassword';<br />
			$config['database'] = 'mydatabase';<br />
			$config['dbdriver'] = 'mysql';<br />
			$config['dbprefix'] = '';<br />
			$config['pconnect'] = false;<br />
			$config['db_debug'] = true;<br />
			$config['active_r'] = true;<br />
			<br />
			$this->load->database(<b>$config</b>);
		</div>

		<p>The individual settings are explained on the configuration page.  You can even specify a data source name.
		DSNs must have this prototype.</p>

		<div class="example">
			$dsn = 'dbdriver://username:password@hostname/database';<br />
			<br />
			$this->load->database($dsn);
		</div>
	</div>

	<div class="content">
		<h1>Connecting to Multiple Databases</h1>

		<p>If you wish to connect to more than one database at the same time you can do the following.</p>

		<div class="example">
			$db1 = $this->load->database('group_one', true);<br />
			$db2 = $this->load->database('group_two', true);
		</div>

		<p>The words 'group_one' and 'group_two' are the group names for the connection settings.  By setting the
		second parameter to <b>true</b> the method will return the database object instead of assigning it to the
		carbon object.</p>

		<p>When you connect this way you will use your object name to call the methods.</p>

		<div class="example">
			$this->db->query();<br />
			$this->db->result();<br />
			<br />
			// You will use the following instead...<br />
			<br />
			$db1->query();<br />
			$db1->result();
		</div>
	</div>
</body>

</html>
